package predic8.couchdb;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import org.jcouchdb.db.Database;

public class FileScanner {

  /* 
   * Connecting to a database, using the 
   * server address and the name of the database.
   * Note that the database have to be created before.
   */
  Database db = new Database("localhost", "filesdb");

  public static void main(String[] args) {
    FileScanner fs = new FileScanner();
    /* 
     * Choose the directory to be analyzed.
     * It can take few minutes to analyze large directories.
     */
    fs.processDir(new File("C:\\"));
  }
  
  void processDir(File f) {
    if (f.isFile()) {
      Map<String, Object> doc = new HashMap<String, Object>();
      doc.put("name", f.getName());
      doc.put("path", f.getAbsolutePath());
      doc.put("size", f.length());
      db.createDocument(doc);
    } else {
      File[] fileList = f.listFiles();
      if (fileList == null) return;
      for (int i = 0; i < fileList.length; i++) {
        try {
          processDir(fileList[i]);
        } catch (Exception e) {
          System.out.println(e);
        }
      }
    }
  }
}